from reconcile.utils import amtool
from reconcile.test.fixtures import Fixtures


def test_check_good_config():
    am_config = Fixtures("amtool").get("alertmanager.yaml")
    result = amtool.check_config(am_config)
    assert result


def test_check_bad_config():
    am_config = "bad: config"
    result = amtool.check_config(am_config)
    assert not result


def test_config_routes_test():
    am_config = Fixtures("amtool").get("alertmanager.yaml")
    labels = {"service": "foo1"}
    result = amtool.config_routes_test(am_config, labels)
    assert result
    assert str(result) == "team-X-mails"

    labels["severity"] = "critical"
    result = amtool.config_routes_test(am_config, labels)
    assert result
    assert str(result) == "team-X-pager"
